diff --git a/Documentation/devicetree/bindings/phy/qcom,usb-snps-femto-v2.yaml b/Documentation/devicetree/bindings/phy/qcom,usb-snps-femto-v2.yaml
index 0dfe691..227c097 100644
--- a/Documentation/devicetree/bindings/phy/qcom,usb-snps-femto-v2.yaml
+++ b/Documentation/devicetree/bindings/phy/qcom,usb-snps-femto-v2.yaml
@@ -50,6 +50,131 @@ properties:
   vdda33-supply:
     description: phandle to the regulator 3.3V supply node.
 
+  qcom,hs-disconnect:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      This adjusts the voltage level for the threshold used to
+      detect a disconnect event at the host. Possible values are.
+      7 -> +21.56%
+      6 -> +17.43%
+      5 -> +13.32%
+      4 -> +9.73%
+      3 -> +6.3
+      2 -> +3.17%
+      1 -> 0, Design default%
+      0 -> -2.72%
+
+  qcom,squelch-detector:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      This adjusts the voltage level for the threshold used to
+      detect valid high-speed data. Possible values are
+      7-> -20.90%
+      6-> -15.60%
+      5-> -10.30%
+      4-> -5.30%
+      3-> 0, Design default%
+      2-> +5.30%
+      1-> +10.60%
+      0-> +15.90%
+
+  qcom,hs-amplitude:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      This adjusts the high-speed DC level voltage.
+      Possible values are
+      15-> +26.70%
+      14-> +24.30%
+      13-> +22.20%
+      12-> +20.00%
+      11-> +17.80%
+      10-> +15.60%
+      9-> +13.30%
+      8-> +11.10%
+      7-> +8.90%
+      6-> +6.50%
+      5-> +4.40%
+      4-> +2.30%
+      3-> 0, Design default%
+      2-> -2.20%
+      1-> -4.40%
+      0-> -6.60%
+
+  qcom,pre-emphasis-duration:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      This signal controls the duration for which the
+      HS pre-emphasis current is sourced onto DP<#> or DM<#>.
+      The HS Transmitter pre-emphasis duration is defined in terms of
+      unit amounts. One unit of pre-emphasis duration is approximately
+      650 ps and is defined as 1X pre-emphasis duration.
+      Possible values are
+      1-> 1x, short pre-emphasis current duration
+      0-> 2x, long pre-emphasis current duration
+
+  qcom,pre-emphasis-amplitude:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      This signal controls the amount of current sourced to
+      DP<#> and DM<#> after a J-to-K or K-to-J transition.
+      The HS Transmitter pre-emphasis current is defined in terms of unit
+      amounts. One unit amount is approximately 2 mA and is defined as
+      1X pre-emphasis current.
+      Possible values are
+      3-> HS Transmitter pre-emphasis circuit sources 3x pre-emphasis
+      current.
+      2-> (design default) HS Transmitter pre-emphasis circuit sources 2x
+      pre-emphasis current.
+      1-> HS Transmitter pre-emphasis circuit sources 1x pre-emphasis
+      current.
+      0-> HS Transmitter pre-emphasis circuit sources 4x pre-emphasis
+      current.
+
+  qcom,hs-rise-fall-time:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      This adjusts the rise/fall times of the high-speed waveform.
+      Possible values are
+      3-> -41.0%
+      2-> 0, Design default
+      1-> +28.1
+      0-> +54.3%
+
+  qcom,hs-crossover-voltage:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      This adjusts the voltage at which the DP<#> and DM<#>
+      signals cross while transmitting in HS mode.
+      Possible values are
+      3-> 0, Default setting
+      2-> +28 mV
+      1-> -31 mV
+      0-> Reserved
+
+  qcom,hs-output-impedance:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      In some applications, there can be significant series resistance
+      on the D+ and D- paths between the transceiver and cable. This adjusts
+      the driver source impedance to compensate for added series
+      resistance on the USB.
+      3-> Source impedance is decreased by approximately 2.3 ohms
+      2-> 0, Design default
+      1-> Source impedance is increased by approximately 2.6 ohms
+      0-> Source impedance is increased by approximately 6.1 ohms
+
+  qcom,ls-fs-output-impedance:
+    $ref: /schemas/types.yaml#/definitions/uint32
+    description:
+      This adjusts the low- and full-speed single-ended source
+      impedance while driving high. The following adjustment values are based
+      on nominal process, voltage, and temperature.
+      15-> -10.53%
+      7-> -5.57%
+      3-> 0, Design default
+      1-> +6.12%
+      0-> +13.10%
+
 required:
   - compatible
   - reg